import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PigActor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PigActor extends Actor
{
    //The variables:
    //Velocity
    int dy =0;
    
    //Gravity
    int g =2;
    
    //Jump height
    int JUMPBOOST =-25;
    
    //Only double-jumps are allowed, not more
    int jump =0;
    
    //Dont jump too fast
    int jumpdelay =0;
    /**
     * Act - do whatever the PigActor wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        //If touching obstacle, GameOver
        if (getOneIntersectingObject(Obstacle.class) != null)
        {
            //Play lose sound
            Greenfoot.playSound("aww.wav");
            
            //add Game-Over image + end game
            GameOver off = new GameOver();
            getWorld().addObject(off, getWorld().getWidth()/2, getWorld().getHeight()/2);
            Greenfoot.stop();
        }
        
        //Falling down, if not at the bottom yet
        if (getY() + dy > getWorld().getHeight() - 20)
        {
            setLocation(getX(), getWorld().getHeight() - 20);
        } else {
            setLocation(getX(), getY() + dy); 
        }
        dy = dy + g;
        
        //If space is pressed, Pigginator jumps
        if (Greenfoot.isKeyDown("space") && jump != 1 && jumpdelay == 0)
        {
            //Play jumps sound
            Greenfoot.playSound("jump.wav");
            
            //jump
            dy = JUMPBOOST;
            
            //to avoid tripple-jump
            jump = jump + 1;
            
            //to avoid jumping 2 times in a row instantly
            jumpdelay = 10;
        }
        
        //Count jumpdelay down
        if (jumpdelay != 0)
        {
            jumpdelay = jumpdelay - 1;
        }
        
        //If landed, reset the number of jumps
        if (getY() == getWorld().getHeight() - 20)
        {
            jump =0;
        }
    }    
}
