import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class PigWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PigWorld extends World
{
    //The variables
    //distance between obstacles
    int obdistance =100;
    int dist =0;
    
    //counter
    int counter =0;
    
    //score
    int score =0;
    
    //need this one later
    Score scObj = null;
    
    //targeted score
    int finish=0;
    
    /**
     * Constructor for objects of class PigWorld.
     * 
     */
    public PigWorld()
    {    
        //Create a new world with 600x400 cells with a cell size of 1x1 pixels
        super(600, 400, 1, false); 
        
        //Set paint order
        setPaintOrder(Obstacle.class, PigActor.class, Score.class, GameOver.class);
        
        //Create a new Pigginator
        PigActor pig = new PigActor();
        
        //Set pig to the world
        addObject(pig, 100, getHeight()-50);
        
        //Create a score Object and set it to 0
        scObj = new Score();
        scObj.setScore(0);
        
        //Add that one to the world
        addObject(scObj, getWidth() - 100, 20);
        
        //Set the targeted score
        finish = Greenfoot.getRandomNumber(100) + 40;
    }
    
    public void act()
    {
        //set the random distance
        dist = obdistance - Greenfoot.getRandomNumber(65);
        
        //Spawn new obstacles with that distance
        if (counter > dist)
        {
            //Create a new one
            Obstacle ob = new Obstacle();
            
            //Add it
            addObject(ob, getWidth(), getHeight() - Greenfoot.getRandomNumber(getHeight()/2) + 200);
            
            //Reset counter
            counter =0;
            
            //count the obstacles as score
            score = score + 1;
            scObj.setScore(score);
        } else {
            //count up
            counter = counter + 1;
        }
        
        //are you finished?
        if (score == finish)
        {
            //play victory sound
            Greenfoot.playSound("yay.wav");
            
            //Create new victory-class
            Victory win = new Victory();
            
            //Show it
            addObject(win, getWidth()/2, getHeight()/2);
            
            //Stop the game
            Greenfoot.stop();
        }
    }
}
